<template lang="pug">
Box(
  :title="$t('page.profile.staking.withdrawal.title')",
  :info="$t('page.profile.staking.withdrawal.min')"
)
  form(@submit.prevent="submit")
    .field
      input(v-model="amount" :placeholder="$t('page.profile.staking.withdrawal.placeholder')")
    .field
      buttons
        b-button(as="button", fullwidth) {{ $t('buttons.stake') }}
  p.hint {{ $t('page.profile.staking.withdrawal.hint') }}
</template>

<script lang="ts">
import Vue from "vue";
import Component from "vue-class-component";
import { VModel, Prop, Watch } from "vue-property-decorator";
import { BigNumber } from "bignumber.js";
import { UserModule } from "./../../store/module/UserModule";
import { Web3Module } from "./../../store/module/Web3Module";
import { Contract } from "web3-eth-contract";
import { PoolModule } from "../../store/module/PoolModule";
import { Stake } from "../../store/module/sharedTypes";
import Web3 from "web3";

@Component({
  components: {
    Box: () => import("../Box.vue"),
  },
})
export default class StakeComponent extends Vue {
  minimalAmount = "0";
  amount: number = 0;

  get account() {
    return this.$store.getters["Web3Module/account"];
  }

  get user(): UserModule.User {
    return this.$store.getters["UserModule/user"];
  }

  get memePool(): PoolModule.Pool {
    return this.$store.getters["PoolModule/memePool"];
  }

  get web3(): Web3 {
    return this.$store.getters["Web3Module/web3"];
  }

  get token(): Contract {
    return this.$store.getters["Web3Module/token"];
  }

  @Watch("user")
  onUserChange() {
    this.load();
  }

  @Watch("memePool")
  onPoolChange() {
    this.load();
  }

  async submit() {
    if (this.amount < parseInt(this.minimalAmount)) {
      return this.$notify({
        title: "Staking sum is lower than minimal",
        type: "error",
      })
    }
    if (this.memePool.id === 0) return
    const pool: Contract = await this.$store.dispatch("Web3Module/getPoolInstance", this.memePool.address)
    let referer = await pool.methods.owner().call()
    if (referer.toLowerCase() === this.account.toLowerCase()) {
      referer = "0x" + "0".repeat(42)
    }

    try {
      const balance = await this.token.methods.balanceOf(this.account).call()
      if (new BigNumber(balance).isLessThan(new BigNumber(this.amount).multipliedBy(10 ** 18))) {
        return this.$notify({
          title: "Insufficient IBT balance",
          type: "error",
        })
      }
      await pool.methods.stake(this.web3.utils.toWei(String(this.amount), "ether"), referer).send({
        from: this.account
      })
      await this.$store.dispatch("UserModule/getUser", this.account)
      this.$notify({
        title: "Succefully staked!",
        type: "success",
      })
    } catch(e) {
      return this.$notify({
        title: "Error while staking",
        type: "error",
      })
    }
  }

  async load() {
    if (!this.user?.address) return;
    if (this.memePool.id === 0) return;

    this.minimalAmount = new BigNumber(this.memePool!.options!.minimalTokensForStake).dividedBy(10 ** 18).toString()
  }

  mounted() {
    this.load()
  }
}
</script>

<style lang="scss" scoped>
.field {
  width: 100%;
  margin-bottom: 1.5rem;
  input {
    font-size: 0.875rem;
    font-weight: 500;
    color: #fff;
    width: 100%;
    padding: 1rem;
    background: rgba($color: #000000, $alpha: 0.3);
    border: 1px solid rgba($color: #fff, $alpha: 0.07);
    border-radius: 11px;
    outline: none !important;
    transition: border 0.2s ease-in-out;
    &::placeholder {
      font-size: 0.875rem;
      font-weight: 500;
      color: #434144;
    }
    &:focus {
      border-color: rgba($color: #fff, $alpha: 0.2);
    }
  }
}

.hint {
  font-size: 0.8125rem;
  font-weight: 500;
  text-align: center;
  color: #8e8e8e;
  margin-top: 0.875rem;
}
</style>